/* $Id: mcl_includes.h,v 1.2 2003/09/26 10:55:20 roca Exp $ */
/*
 *  Copyright (c) 1999-2003 INRIA - Universite Paris 6 - All rights reserved
 *  (main author: Vincent Roca - vincent.roca@inrialpes.fr)
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 *  USA.
 */

#ifndef MCL_INCLUDES_H  /* { */
#define MCL_INCLUDES_H

#ifdef SOLARIS
#define __EXTENSIONS__		/* XXX: we have pbs without on Solaris 2.5.1 */
#endif

#include <stdio.h>
#include <stdlib.h>
#include <iostream>
using namespace std;

#include <errno.h>
extern int errno;
#include <string.h>
#include <fcntl.h>
#include <signal.h>
#include <ctype.h>
#include <sys/types.h>
#include <math.h>

#if defined(DEBUG) && defined(MPATROL) && !defined(WIN32)
#include <mpatrol.h>
#else
#include <malloc.h>
#endif
#include <new>		// required by _set_new_handler on linux


#ifdef WIN32	/* WIN32 */

#include <time.h>
#include <io.h>
#include <winsock2.h>
#include <ws2tcpip.h>

#else	/* UNIX Systems */

#include <unistd.h>
#include <values.h>	/* for MAXINT */
#include <strings.h>
#include <sys/time.h>
#include <sys/wait.h>
#include <pthread.h>
#include <sys/uio.h>

#ifdef SOLARIS
#include <netinet/in_systm.h>
#endif /* SOLARIS */

#include <netinet/in.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <netinet/ip.h>
#include <netinet/udp.h>

#endif	/* OS */

/****** MCL includes **********************************************************/


#include "../common/mcl_osdep.h"	// First: define portable types...
#include "mcl_profile.h"	// Second: define the MCL-NORM default profile
#include "../common/mcl_lib_api.h"

#include "../common/mcl_addr.h"
#include "../common/mcl_version.h"
#include "../common/mcl_debug.h"

#include "mcl.h"	/* general purpose MCL constants */
#include "mcl_error.h"
#include "mcl_time.h"

#ifdef RSE_FEC
#include "../common/rse_fec.h"
#endif
#ifdef LDPC_FEC
#include "../../../ldpc/src/ldpc_fec.h"
#endif

#include "mcl_rx_storage.h"
#ifdef VIRTUAL_TX_MEM
#include "mcl_vtmem.h"
#endif
#ifdef VIRTUAL_RX_MEM
#include "mcl_vrmem.h"
#endif

#include "mcl_data.h"

#ifdef RLC
#include "mcl_rlc.h"
#endif
#ifdef FLIDS
#include "mcl_flid_sl.h"
#endif

#include "mcl_lct_hdr.h"
#include "mcl_alc_hdr.h"
#include "mcl_stats.h"
#include "mcl_fsm.h"
#include "mcl_cb.h"
#include "mcl_fec.h"
#include "mcl_proto.h"

#endif /* }  MCL_INCLUDES_H */
